//+------------------------------------------------------------------+
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1  Red
#property indicator_color2  Blue
#property indicator_color3  Green
#property indicator_style3  STYLE_DOT
#property indicator_color4  Brown
#property indicator_style4  STYLE_DOT
#property indicator_color5  Lavender
#property indicator_color6  Green
#property indicator_style6  STYLE_DASH
#property indicator_color7  Brown
#property indicator_style7  STYLE_DASH

//
//
//
//
//

extern double Tenkan       = 9;
extern double Kijun        = 26;
extern double Senkou       = 52;
extern int    ChinkouShift = -26;
extern double SmoothLength = 10;
extern double SmoothPhase  = 0;
extern bool   SmoothDouble = true;

//
//
//
//
//

double Tenkan_Buffer[];
double Kijun_Buffer[];
double SpanA_Buffer[];
double SpanB_Buffer[];
double Chinkou_Buffer[];
double SpanA2_Buffer[];
double SpanB2_Buffer[];

//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{
   
     SetIndexBuffer(0,Tenkan_Buffer);                                  SetIndexLabel(0,"Tenkan Sen");
     SetIndexBuffer(1,Kijun_Buffer);                                   SetIndexLabel(1,"Kijun Sen");
     SetIndexBuffer(2,SpanA_Buffer);  SetIndexStyle(2,DRAW_HISTOGRAM); SetIndexLabel(2,"Span A"); 
     SetIndexBuffer(3,SpanB_Buffer);  SetIndexStyle(3,DRAW_HISTOGRAM); SetIndexLabel(3,"Senkou Span B");
     SetIndexBuffer(4,Chinkou_Buffer);                                 SetIndexLabel(4,"Chinkou Span");
     SetIndexBuffer(5,SpanA2_Buffer);                                  SetIndexLabel(5,"Span A2");
     SetIndexBuffer(6,SpanB2_Buffer);                                  SetIndexLabel(6,"Senkou Span B2");
     
     SetIndexShift(2,Kijun);  
     SetIndexShift(3,Kijun);  
     SetIndexShift(4,ChinkouShift); 
     SetIndexShift(5,Kijun);
     SetIndexShift(6,Kijun);       
     
     IndicatorShortName("Ichimoku2");
     
return(0);
}

//
//
//
//
//

int deinit() {  return(0);}

//
//
//
//                           
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,k,limit;
   
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1); 

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
       
       double thi    = High[i];
       double tlo    = Low[i];
       double tprice = 0;
       if (i >= Bars - Tenkan) continue;
       for(k = 1; k < Tenkan; k++)
       {
           tprice = High[i+k];
           if(thi < tprice)  thi = tprice;
         
           tprice = Low[i+k];
           if(tlo  > tprice) tlo = tprice;
       }
       
       if ((thi+tlo) > 0.0) 
            Tenkan_Buffer[i] = iDSmooth((thi + tlo)/2,Tenkan,SmoothPhase,SmoothDouble,i,0); 
       else Tenkan_Buffer[i] = iDSmooth(0,            Tenkan,SmoothPhase,SmoothDouble,i,0);
       
       //
       //
       //
       //
       //
       
       double khi    = High[i];
       double klo    = Low[i];
       double kprice = 0;
       if  (i >= Bars - Kijun) continue;
       for (k = 1; k < Kijun; k++)
       {
          kprice = High[i+k];
          if(khi < kprice)  khi  = kprice;
         
          kprice = Low[i+k];
          if(klo  > kprice) klo  = kprice;
       }
        
       if ((khi+klo) > 0.0) 
            Kijun_Buffer[i] = iDSmooth((khi + klo)/2,Kijun,SmoothPhase,SmoothDouble,i,20); 
       else Kijun_Buffer[i] = iDSmooth(0,            Kijun,SmoothPhase,SmoothDouble,i,20);
            
       //
       //
       //
       //
       //
        
       double shigh  = High[i];
       double slow   = Low[i];
       double sprice = 0;
       if (i >= Bars - Senkou) continue;
       for(k = 1; k < Senkou; k++)
       {
           sprice = High[i+k];
           if(shigh < sprice) shigh = sprice;
         
           sprice = Low[i+k];
           if(slow  > sprice) slow  = sprice;
        }
        
        SpanA_Buffer[i]   = (Kijun_Buffer[i] + Tenkan_Buffer[i])/2;
        SpanA2_Buffer[i]  = (Kijun_Buffer[i] + Tenkan_Buffer[i])/2;
        SpanB_Buffer[i]   =  iDSmooth((shigh + slow)/2,Senkou,SmoothPhase,SmoothDouble,i,40);             
        SpanB2_Buffer[i]  =  iDSmooth((shigh + slow)/2,Senkou,SmoothPhase,SmoothDouble,i,60);             
        Chinkou_Buffer[i] =  iDSmooth(Close[i],SmoothLength,  SmoothPhase,SmoothDouble,i,80);                  
   }
return(0);
}
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double wrk[][100];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}  